import sys, pygame, math, random

size = width, height =  512, 512
minradius = 2
maxspeed = 1
minspeed = 0
depthspeeds = [1,1,1,1,1,1,1,1,1]

#edit any of those numbers as you wish.
#speeds may be negative or positive. negative is counterclockwise.
#you must have at least log height/minradius base 2 numbers in depthspeeds.
#comment out the depthspeeds line to randomize.
#maxspeed and minspeed are only used if depthspeeds are randomized.



depths = int(math.log(height/minradius, 2))
random.seed()
if "depthspeeds" not in globals():
  depthspeeds = [random.uniform(minspeed, maxspeed) for x in xrange(depths)]
black = 0, 0, 0
class circle:
  def __init__(self, angle, depth, distance):
    self.radius = height/2**depth/2
    self.depth = depth
    self.angle = angle
    self.distance = distance
    if depth < depths-1:
      self.child1 = circle(0, depth+1, height/2**depth/4)
      self.child2 = circle(math.pi, depth+1, height/2**depth/4)
    self.angleinc = math.atan2(depthspeeds[depth],distance)

  def docircle(self, pivotx, pivoty):
    posx = pivotx+self.distance*math.cos(self.angle)
    posy = pivoty+self.distance*math.sin(self.angle)
    pygame.draw.circle(screen, (255,255,255), (posx, posy), self.radius, 1)
    self.angle += self.angleinc
    if self.depth < depths-1:
      self.child1.docircle(posx, posy)
      self.child2.docircle(posx, posy)

pygame.init()
screen = pygame.display.set_mode(size)

circle0 = circle(0, 0, 0)
while 1:
        for event in pygame.event.get():
            if event.type == pygame.QUIT: sys.exit()

        screen.fill(black)
        circle0.docircle(width/2, height/2)

        pygame.display.flip()

#by Richard A. Nichols III

